// Code generated by sqlc. DO NOT EDIT.
// source: queries.sql

package queries

import (
	"context"
	"encoding/json"

	"github.com/google/uuid"
)

const createPersoon = `-- name: CreatePersoon :exec
INSERT INTO nlx_demo_brp.personen (
    identificatie,
    data
)
VALUES ($1, $2)
`

type CreatePersoonParams struct {
	Identificatie uuid.UUID
	Data          json.RawMessage
}

func (q *Queries) CreatePersoon(ctx context.Context, arg *CreatePersoonParams) error {
	_, err := q.exec(ctx, q.createPersoonStmt, createPersoon, arg.Identificatie, arg.Data)
	return err
}

const deletePersoon = `-- name: DeletePersoon :exec
DELETE FROM nlx_demo_brp.personen
WHERE identificatie = $1
`

func (q *Queries) DeletePersoon(ctx context.Context, identificatie uuid.UUID) error {
	_, err := q.exec(ctx, q.deletePersoonStmt, deletePersoon, identificatie)
	return err
}

const deregisterPersoon = `-- name: DeregisterPersoon :exec
UPDATE nlx_demo_brp.personen
SET data = jsonb_set(data::jsonb, '{verblijfadres}', '{}')
WHERE identificatie = $1
`

func (q *Queries) DeregisterPersoon(ctx context.Context, identificatie uuid.UUID) error {
	_, err := q.exec(ctx, q.deregisterPersoonStmt, deregisterPersoon, identificatie)
	return err
}

const getPersoon = `-- name: GetPersoon :one
SELECT identificatie,
    data
FROM nlx_demo_brp.personen
WHERE identificatie = $1
`

func (q *Queries) GetPersoon(ctx context.Context, identificatie uuid.UUID) (*NlxDemoBrpPersonen, error) {
	row := q.queryRow(ctx, q.getPersoonStmt, getPersoon, identificatie)
	var i NlxDemoBrpPersonen
	err := row.Scan(&i.Identificatie, &i.Data)
	return &i, err
}

const getPersoonByBsn = `-- name: GetPersoonByBsn :one
SELECT identificatie,
    data
FROM nlx_demo_brp.personen
WHERE data ->> 'burgerservicenummer' = $1
`

func (q *Queries) GetPersoonByBsn(ctx context.Context, data json.RawMessage) (*NlxDemoBrpPersonen, error) {
	row := q.queryRow(ctx, q.getPersoonByBsnStmt, getPersoonByBsn, data)
	var i NlxDemoBrpPersonen
	err := row.Scan(&i.Identificatie, &i.Data)
	return &i, err
}

const listPersonen = `-- name: ListPersonen :many
SELECT identificatie,
    data
FROM nlx_demo_brp.personen
`

func (q *Queries) ListPersonen(ctx context.Context) ([]*NlxDemoBrpPersonen, error) {
	rows, err := q.query(ctx, q.listPersonenStmt, listPersonen)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*NlxDemoBrpPersonen{}
	for rows.Next() {
		var i NlxDemoBrpPersonen
		if err := rows.Scan(&i.Identificatie, &i.Data); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const registerPersoon = `-- name: RegisterPersoon :exec
UPDATE nlx_demo_brp.personen
SET data = jsonb_set(data::jsonb, '{verblijfadres}', $2)
WHERE identificatie = $1
`

type RegisterPersoonParams struct {
	Identificatie uuid.UUID
	Address       json.RawMessage
}

func (q *Queries) RegisterPersoon(ctx context.Context, arg *RegisterPersoonParams) error {
	_, err := q.exec(ctx, q.registerPersoonStmt, registerPersoon, arg.Identificatie, arg.Address)
	return err
}

const updatePersoon = `-- name: UpdatePersoon :exec
UPDATE nlx_demo_brp.personen
SET data = $1
WHERE identificatie = $2
`

type UpdatePersoonParams struct {
	Data          json.RawMessage
	Identificatie uuid.UUID
}

func (q *Queries) UpdatePersoon(ctx context.Context, arg *UpdatePersoonParams) error {
	_, err := q.exec(ctx, q.updatePersoonStmt, updatePersoon, arg.Data, arg.Identificatie)
	return err
}
